/* slider_main.cpp */
/* Pavel Surynek */

#include "slider.h"


SLIDER slider1, slider2;
SLIDER copy;
SOLUTION solution1;
SOLUTION solution2;


int perm1[] = {5, 2, 3, 4, 1};
int perm2[] = {1, 4, 3, 2, 5};


int main(int UNUSED(argc), char **UNUSED(argv))
{
	int i /*, j, k*/;
	clock_t begin, end;
/*
	int sig = calc_signature(perm1, perm2, 5);
	printf("Signature:%d\n", sig);
	exit(0);
*/
	for (i = 0; i < MAX_DEPTHS_COUNT; ++i)
	{
		MAX_DEPTHS[i] = 0;
	}

	reset_estimations();

//	FILE *fout;
//	fout = fopen("7_6_9___b1.txt", "w");

	begin = clock();

	init_solution(1024, &solution1);
	init_solution(1024, &solution2);

	init_slider(0, 7, 7, 12, &slider1);
	swap_goal(2, 5, &slider1);

	INT_set care;

//	care.insert(1);
	care.insert(2);
	care.insert(3);
	care.insert(4);
	care.insert(5);
//	care.insert(6);
//	care.insert(7);


	for (int i = 0; i <= slider1.m_V; ++i)
	{
		care.insert(i);
	}

	print_slider(&slider1);

	if (solve_IDA_PL_xaos(&slider1, &solution1, care, clock(), 1000.0))
	{
		print_solution(&solution1);
	}
/*
	copy_slider(&slider1, &slider2);
	swap_slider(&slider2);

	solve_slider_deepening(48, 1000.0, &slider1, &slider2,  &solution1, &solution2, fout);
*/
//	double ratio = analyze_tri_signatures(slider1.m_V);
//	printf("Tri signatures ratio: %f\n", ratio);
//	fclose(fout);

//	generate_IDA_PL_infinity(&slider1, &slider2, &solution1, &solution2);
//	generate_IDA_infinity(&slider1, &slider2, &solution1, &solution2);
//	generate_star_infinity(&slider1, &slider2, &solution1, &solution2);
//	generate_infinity(&slider1, &slider2, &solution1, &solution2);

	print_slider(&slider1);

	end = clock();
	printf("Time:%.3f\n", (end - begin) / (double)CLOCKS_PER_SEC);
	printf("Steps:%ld\n", STEPS);
	printf("Solution length:%d\n", solution1.m_M);

	return 0;
}
